// following is an example of general pattern that handles, enter, update, and exit
// 5:13:14 first part (selectAll) selects empty elements because there are no circle) 
// .data return data join it self then you enter and append


import { scaleOrdinal } from 'd3';  

const xPosition = (d, i) => i*120 + 60;

const colorScale = scaleOrdinal ()
	.domain(['apple', 'lemon'])
	.range(['#c11d1d', '#eae600']);

const radiusScale = scaleOrdinal ()
	.domain(['apple', 'lemon'])
	.range([50, 30]);


export const fruitBowl = (selection, props) => {
  const { fruits, height } = props;
 
  
  const groups = selection.selectAll('g')
  	.data(fruits);
  
  const groupsEnter = groups.enter().append('g');
  groupsEnter
  	.merge(groups)
  		.attr('transform', (d,i) => 
            `translate(${i * 180 + 60},${height/3})`)
  
   const groupsExit = groups.exit().append('g');
   groupsExit
   	.merge(groups)
  		 .attr('transform', (d,i) => 
            `translate(${i * 180 + 60},${height/3})`)
   

 
  groupsEnter.append('circle')
  	.merge(groups.select('circle'))
      .attr('fill', d => colorScale(d.type)) 
//   		.attr('r', d => radiusScale(d.type))
  	.transition().duration(1000)
  		.attr('r', d => radiusScale(d.type))
  	
 
  
  groupsEnter.append('text')
  	.merge(groups.select('text'))
  		.text(d => d.type)
  		.attr('y', 100)

//  groupsExit.append('circle')
//  	.transition().duration(1000)
//  		.attr('r', 0)
//  	.remove;

 	groups.exit()
     	.remove(); 
 	  

  
  
}